diff -Naur --exclude=CVS --exclude=configs linux/hpc/syscalls.c linux-openmosix/hpc/syscalls.c
--- linux/hpc/syscalls.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/syscalls.c	2003-09-10 20:50:13.000000000 +0200
@@ -0,0 +1,2520 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+#include <linux/sched.h>
+#include <linux/hpc.h>
+#include <linux/timex.h>
+#include <linux/utime.h>
+#include <linux/utsname.h>
+#include <linux/serial.h>
+#include <linux/serialP.h>
+#include <linux/random.h>
+#include <linux/quotacompat.h>
+#include <linux/mm.h>
+#include <linux/sysctl.h>
+#include <linux/socket.h>
+#include <linux/nfs.h>
+#include <linux/net.h>
+#include <linux/sunrpc/svc.h>
+#include <linux/nfsd/nfsd.h>
+#include <linux/nfsd/syscall.h>
+#include <hpc/protocol.h>
+#include <hpc/routines.h>
+#include <asm/processor.h>
+#include <linux/smp_lock.h>
+#include <asm/uaccess.h>
+#include <asm/ipc.h>
+#include <asm/poll.h>
+#include <linux/sem.h>
+#include <linux/msg.h>
+#include <linux/shm.h>
+#include <linux/hdreg.h>
+#include <linux/capability.h>
+#include <linux/module.h>
+#include "../ipc/util.h"
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+
+
+/* In this file we have actually most of DFSA's capability, namely to locally execute
+ * some file system related system calls. You'll notice that for each fs related syscall
+ * there is a DFSA handling variant (the long way) or the non DFSA variant (the short way 
+ * because we are just shipping the syscall number and the registers back. 
+ * When integrating a new file system with openMosix' DFSA, make sure to drop by this file and
+ * have a look around 
+ * Moshe Bar */
+
+extern caddr_t sys_call_table[];
+
+#define	set_file_name(x)	do { \
+				unsigned long fn = ((int *)&regs)[x]; \
+				set_write_region(fn, strlen_user((char *)fn)); \
+				} while(0);
+#define	ARG(x)			(((int *)&regs)[x])
+#if BITS_PER_LONG == 32
+#define	LARG(x)			(*((long long *)(((int *)&regs)+(x))))
+#else
+#define	LARG(x)			(*((long *)(((int *)&regs)+(x))))
+#endif
+
+#ifdef CONFIG_MOSIX_DFSA
+#define	RESULT_IS_FINAL(result)	((result) >= 0 || ( \
+	(result) != -EDOITATHOME && (result) != -EINTR && \
+	(result) != -ERESTARTSYS && (result) != -ERESTARTNOINTR && \
+	(result) != -ERESTARTNOHAND && (result) != -EAGAIN))
+#endif /* CONFIG_MOSIX_DFSA */
+
+int
+remote_sys_getpid(int n, struct pt_regs regs)
+{
+	return(current->mosix.depinfo.tgid);
+}
+
+int
+remote_sys_gettid(int n, struct pt_regs regs)
+{
+	return(current->mosix.mypid);
+}
+
+long
+remote_sys_getitimer(int n, struct pt_regs regs)
+{
+	extern asmlinkage long sys_getitimer(int, struct itimerval *);
+
+	if(*((int *)&regs) == ITIMER_REAL)
+	{
+		set_read_region(ARG(1), sizeof(struct itimerval));
+		return(remote_standard_system_call(n, &regs));
+	}
+	return(sys_getitimer(ARG(0), (struct itimerval *)ARG(1)));
+}
+
+long
+remote_sys_setitimer(int n, struct pt_regs regs)
+{
+	extern asmlinkage long sys_setitimer(int, struct itimerval *,
+							struct itimerval *);
+
+	if(*((int *)&regs) == ITIMER_REAL)
+	{
+		if(ARG(1))
+			set_write_region(ARG(1), sizeof(struct itimerval));
+		if(ARG(2))
+			set_read_region(ARG(2), sizeof(struct itimerval));
+		return(remote_standard_system_call(n, &regs));
+	}
+	return(sys_setitimer(ARG(0), (struct itimerval *)ARG(1),
+		(struct itimerval *)ARG(2)));
+}
+
+unsigned long
+remote_sys_brk(int n, struct pt_regs regs)
+{
+	extern asmlinkage unsigned long sys_brk(unsigned long);
+
+	return(sys_brk((unsigned long)ARG(0)));
+}
+
+long
+remote_sys_mprotect(int n, struct pt_regs regs)
+{
+	extern asmlinkage long sys_mprotect(unsigned long, size_t,
+								unsigned long);
+
+	return(sys_mprotect((unsigned long)ARG(0), (size_t)ARG(1),
+		(unsigned long)ARG(2)));
+}
+
+long
+remote_sys_msync(int n, struct pt_regs regs)
+{
+	return(0);	/* no writeable file-mapping allowed remotely! */
+}
+
+long
+remote_sys_munlock(int n, struct pt_regs regs)
+{
+	/* since remote mlocking is not allowed, but we are still here,
+	 * this must only be a "make-sure" call */
+	return(0);
+}
+
+long
+remote_sys_munlockall(int n, struct pt_regs regs)
+{
+	/* since remote mlocking is not allowed, but we are still here,
+	 * this must only be a "make-sure" call */
+	return(0);
+}
+
+unsigned long
+remote_sys_mremap(int n, struct pt_regs regs)
+{
+	extern asmlinkage unsigned long sys_mremap(unsigned long, unsigned long,
+				 unsigned long, unsigned long, unsigned long);
+
+	return(sys_mremap((unsigned long)ARG(0), (unsigned long)ARG(1),
+		(unsigned long)ARG(2), (unsigned long)ARG(3),
+		(unsigned long)ARG(4)));
+}
+
+int
+remote_sys_modify_ldt(int n, int func, void *ptr, unsigned long bytecount)
+{
+	extern asmlinkage int sys_modify_ldt(int, void *, unsigned long);
+
+	return(sys_modify_ldt(func, ptr, bytecount));
+}
+
+long
+remote_sys_sched_yield(void)
+{
+	extern asmlinkage long sys_sched_yield(void);
+
+	return(sys_sched_yield());
+}
+
+long
+remote_sys_mincore(int n, struct pt_regs regs)
+{
+	extern asmlinkage long sys_mincore(unsigned long, size_t,
+							unsigned char *);
+
+	return(sys_mincore((unsigned long)ARG(0), (size_t)ARG(1),
+		(unsigned char *)ARG(2)));
+}
+
+long
+remote_sys_madvise(int n, struct pt_regs regs)
+{
+	extern asmlinkage long sys_madvise(unsigned long, size_t, int);
+
+	return(sys_madvise((unsigned long)ARG(0), (size_t)ARG(1), (int)ARG(2)));
+}
+
+long
+#ifdef CONFIG_MOSIX_DFSA
+remote_sys_close_syscall(int n, struct pt_regs regs)
+#else
+remote_sys_close(int n, struct pt_regs regs)
+#endif /* CONFIG_MOSIX_DFSA */
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_close(unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if((p->files->fd[fd] ||
+		(p->mosix.ttab && !FD_ISSET(fd, p->files->open_fds))) &&
+		enter_remote_dfsa_mode())
+	{
+		result = sys_close((unsigned int)ARG(0));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fchdir(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fchdir(unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->fs->pwd && p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fchdir(fd);
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_ftruncate(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_ftruncate(unsigned int, unsigned long);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_ftruncate(fd, (unsigned long)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_ftruncate64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_ftruncate64(unsigned int, loff_t);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_ftruncate64(fd, (loff_t)LARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fchmod(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fchmod(unsigned int, mode_t);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fchmod(fd, (mode_t)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fchown(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fchown(unsigned int, uid_t, gid_t);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fchown(fd, (uid_t)ARG(1), (gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fchown16(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fchown16(unsigned int, old_uid_t, old_gid_t);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fchown16(fd, (old_uid_t)ARG(1), (old_gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_dup(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_dup(unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_dup(fd);
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_dup2(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_dup2(unsigned int, unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_dup2(fd, (unsigned int)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fsync(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fsync(unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fsync(fd);
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fdatasync(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fdatasync(unsigned int);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fdatasync(fd);
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_write(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	ssize_t result;
+	extern asmlinkage ssize_t sys_write(unsigned int, char *, size_t);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_write(fd, (char *)ARG(1), ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_write_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_read(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	ssize_t result;
+	extern asmlinkage ssize_t sys_read(unsigned int, char *, size_t);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_read(fd, (char *)ARG(1), ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_open(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_open((char *)ARG(0), ARG(1), ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_waitpid(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(int));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_creat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_creat(char *, int);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_creat((char *)ARG(0), ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_link(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_link(const char *, const char *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_link((const char *)ARG(0), (const char *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_file_name(1);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_unlink(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_unlink(const char *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_unlink((const char *)ARG(0));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_execve(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_chdir(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_chdir(char *);
+
+	if(current->fs->pwd && current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_chdir((char *)ARG(0));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_time(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_read_region(ARG(0), sizeof(int));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_mknod(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_chmod(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_chmod(const char *, mode_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_chmod((const char *)ARG(0), (mode_t)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_lchown(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_lchown(const char *, uid_t, gid_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_lchown((const char *)ARG(0), (uid_t)ARG(1),
+								(gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_lchown16(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_lchown16(const char *, old_uid_t, old_gid_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_lchown16((const char *)ARG(0), (old_uid_t)ARG(1),
+							(old_gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_stat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_stat(char *, struct __old_kernel_stat *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_stat((char *)ARG(0),
+					(struct __old_kernel_stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct __old_kernel_stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_stat64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_stat64(char *, struct stat64 *, long);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_stat64((char *)ARG(0), (struct stat64 *)ARG(1),
+								(long)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct stat64));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_mount(int n, struct pt_regs regs)
+{
+	unsigned long arg, len;
+	set_file_name(0);
+	set_file_name(1);
+	if((arg = ARG(2)))
+	{
+		len = TASK_SIZE - arg;
+		if(len > PAGE_SIZE-1)
+			len = PAGE_SIZE-1;
+		set_write_region(ARG(2), len);
+	}
+	if((arg = ARG(4)))
+	{
+		len = TASK_SIZE - arg;
+		if(len > PAGE_SIZE-1)
+			len = PAGE_SIZE-1;
+		set_write_region(ARG(4), PAGE_SIZE-1);
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_oldumount(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_stime(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(int));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fstat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fstat(unsigned int,
+						struct __old_kernel_stat *);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fstat(fd, (struct __old_kernel_stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), sizeof(struct __old_kernel_stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fstat64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_fstat64(unsigned int, struct stat64 *, long);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_fstat64(fd, (struct stat64 *)ARG(1), (long)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), sizeof(struct stat64));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_utime(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_utime(char *, struct utimbuf *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_utime((char *)ARG(0), (struct utimbuf *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	if(ARG(1))
+		set_read_region(ARG(1), sizeof(struct utimbuf));
+	return(remote_standard_system_call(n, &regs));
+}
+
+/* NOTE: sys_utimes is not supported for i386,
+ * but should be implemented for Alpha/Sparc */
+
+long
+remote_sys_access(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_access(const char *, int);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_access((const char *)ARG(0), (int)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rename(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_rename(const char *, const char *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_rename((const char *)ARG(0), (const char *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_file_name(1);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_mkdir(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_mkdir(const char *, int);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_mkdir((const char *)ARG(0), ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rmdir(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_rmdir(const char *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_rmdir((const char *)ARG(0));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_pipe(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), 2 * sizeof(long));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_times(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_read_region(ARG(0), sizeof(struct tms));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_acct(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_umount(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_ioctl(int n, struct pt_regs regs)
+{
+	switch(ARG(1))
+	{
+		/* so many more -- feel free to add: */
+		/* if ambiguous -- add both! */
+		/* but do not include ioctls whose definitions is configurable*/
+		/* also, it is better to not include rare non-tty ioctls,
+		   because it would slow-down the other's performance */
+	case TCGETS:
+	case TIOCGLCKTRMIOS:
+		set_read_region(ARG(2), sizeof(struct termios));
+		break;
+	case TCSETS:
+	case TCSETSF:
+	case TCSETSW:
+	case TIOCSLCKTRMIOS:
+		set_write_region(ARG(2), sizeof(struct termios));
+		break;
+	case TCGETA:
+		set_read_region(ARG(2), sizeof(struct termio));
+		break;
+	case TCSETA:
+	case TCSETAW:
+	case TCSETAF:
+		set_write_region(ARG(2), sizeof(struct termio));
+		break;
+	case TIOCOUTQ:
+	case TIOCGSOFTCAR:
+	case FIONREAD:
+	case FIGETBSZ:
+	case TIOCGETD:
+	case TIOCMGET:
+	case TIOCSERGWILD:
+	case TIOCSERGETLSR:
+	case RNDGETENTCNT:
+		set_read_region(ARG(2), sizeof(int));
+		break;
+	case FIBMAP:
+		set_write_region(ARG(2), sizeof(int));
+		set_read_region(ARG(2), sizeof(int));
+		break;
+	case TIOCPKT:
+	case TIOCSETD:
+	case TIOCSSOFTCAR:
+	case FIONBIO:
+	case TIOCMSET:
+	case TIOCSERSWILD:
+		set_write_region(ARG(2), sizeof(int));
+		break;
+	case TIOCSTI:
+		set_write_region(ARG(2), sizeof(char));
+		break;
+	case TIOCGWINSZ:
+		set_read_region(ARG(2), sizeof(struct winsize));
+		break;
+	case TIOCSWINSZ:
+		set_write_region(ARG(2), sizeof(struct winsize));
+		break;
+	case TIOCGPGRP:
+	case TIOCGSID:
+		set_read_region(ARG(2), sizeof(pid_t));
+		break;
+	case TIOCSPGRP:
+		set_write_region(ARG(2), sizeof(pid_t));
+		break;
+	case TIOCLINUX:
+		/* there are many cases - use the extreme ones: */
+		set_read_region(ARG(2), 1);
+		set_write_region(ARG(2), 36);
+		break;
+	case TIOCTTYGSTRUCT:
+		set_read_region(ARG(2), sizeof(struct tty_struct));
+		break;
+	case TIOCGSERIAL:
+		set_read_region(ARG(2), sizeof(struct serial_struct));
+		break;
+	case TIOCSSERIAL:
+		set_write_region(ARG(2), sizeof(struct serial_struct));
+		break;
+	case TIOCSERGSTRUCT:
+		set_read_region(ARG(2), sizeof(struct async_struct));
+		break;
+	case TIOCGICOUNT:
+		set_read_region(ARG(2), sizeof(struct serial_icounter_struct));
+		break;
+	case HDIO_GETGEO:
+		set_read_region(ARG(2), sizeof(struct hd_geometry));
+		break;
+               /* Socket ioctls see sockios.h and man ioctl_list(2) */
+   
+                   case FIOGETOWN:
+                   case SIOCGPGRP:
+                   case SIOCATMARK:
+                           set_read_region(ARG(2), sizeof(int));
+                           /* fall thru! */
+                   case FIOSETOWN:
+                   case SIOCSPGRP:
+                           set_write_region(ARG(2), sizeof(int));
+                           break;
+                   case SIOCGSTAMP:
+                           set_read_region(ARG(2), sizeof(struct timeval));
+                           break;
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fcntl(int n, struct pt_regs regs)
+{
+	unsigned long f = ARG(1);
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+	long result;
+	extern asmlinkage long sys_fcntl(unsigned int, unsigned int,
+								unsigned long);
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(FD_ISSET(fd, p->files->open_fds) && p->files->fd[fd])
+		switch(f)
+		{
+		case F_DUPFD:
+		case F_GETFL:
+		case F_SETFL:
+			if(!enter_remote_dfsa_mode())
+				break;
+			result = sys_fcntl(fd, f, (unsigned long)ARG(2));
+			leave_remote_dfsa_mode();
+			if(RESULT_IS_FINAL(result))
+				return(result);
+			break;
+		}
+#endif /* CONFIG_MOSIX_DFSA */
+	switch(f)
+	{
+	case F_GETLK:
+		set_read_region(ARG(2), sizeof(struct flock));
+		break;
+	case F_SETLK:
+	case F_SETLKW:
+		set_write_region(ARG(2), sizeof(struct flock));
+		break;
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fcntl64(int n, struct pt_regs regs)
+{
+	unsigned long f = ARG(1);
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+	long result;
+	extern asmlinkage long sys_fcntl64(unsigned int, unsigned int,
+					   unsigned long);
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(FD_ISSET(fd, p->files->open_fds) && p->files->fd[fd])
+		switch(f)
+		{
+		case F_DUPFD:
+		case F_GETFD:
+		case F_SETFD:
+		case F_GETFL:
+		case F_SETFL:
+			if(!enter_remote_dfsa_mode())
+				break;
+			result = sys_fcntl64(fd, f, (unsigned long)ARG(2));
+			leave_remote_dfsa_mode();
+			if(RESULT_IS_FINAL(result))
+				return(result);
+			break;
+		}
+#endif /* CONFIG_MOSIX_DFSA */
+	switch(f)
+	{
+	case F_GETLK:
+		set_read_region(ARG(2), sizeof(struct flock));
+		break;
+	case F_SETLK:
+	case F_SETLKW:
+		set_write_region(ARG(2), sizeof(struct flock));
+		break;
+	case F_GETLK64:
+		set_read_region(ARG(2), sizeof(struct flock64));
+		break;
+	case F_SETLK64:
+	case F_SETLKW64:
+		set_write_region(ARG(2), sizeof(struct flock64));
+		break;
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_olduname(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(struct oldold_utsname));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_chroot(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_ustat(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct ustat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sigpending(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(old_sigset_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_sigaction(int n, struct pt_regs regs)
+{
+	if(ARG(1))
+		set_write_region(ARG(1), sizeof(struct old_sigaction));
+	if(ARG(2))
+		set_read_region(ARG(2), sizeof(struct old_sigaction));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_setrlimit(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(1), sizeof(struct rlimit));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getrlimit(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct rlimit));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_old_getrlimit(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct rlimit));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getrusage(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct rusage));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_gettimeofday(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_read_region(ARG(0), sizeof(struct timeval));
+	if(ARG(1))
+		set_read_region(ARG(1), sizeof(struct timezone));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_settimeofday(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_write_region(ARG(0), sizeof(struct timeval));
+	if(ARG(1))
+		set_write_region(ARG(1), sizeof(struct timezone));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getgroups(int n, struct pt_regs regs)
+{
+	unsigned int ng = ARG(0);
+
+	if(ng > 0 && ARG(1))
+		set_read_region(ARG(1), ng * sizeof(gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getgroups16(int n, struct pt_regs regs)
+{
+	unsigned int ng = ARG(0);
+
+	if(ng > 0 && ARG(1))
+		set_read_region(ARG(1), ng * sizeof(old_gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_setgroups(int n, struct pt_regs regs)
+{
+	unsigned int ng = ARG(0);
+
+	if(ng > 0)
+		set_write_region(ARG(1), ng * sizeof(gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_setgroups16(int n, struct pt_regs regs)
+{
+	unsigned int ng = ARG(0);
+
+	if(ng > 0)
+		set_write_region(ARG(1), ng * sizeof(old_gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+void
+set_select_regions(int n, unsigned long inp, unsigned long outp,
+					unsigned long exp, unsigned long tvp)
+{
+	n = (n + 8*sizeof(long) - 1) / (8*sizeof(long)) * sizeof(long);
+	if(inp)
+	{
+		set_read_region(inp, n);
+		set_write_region(inp, n);
+	}
+	if(outp)
+	{
+		set_read_region(outp, n);
+		set_write_region(outp, n);
+	}
+	if(exp)
+	{
+		set_read_region(exp, n);
+		set_write_region(exp, n);
+	}
+	if(tvp)
+	{
+		set_read_region(tvp, sizeof(struct timeval));
+		set_write_region(tvp, sizeof(struct timeval));
+	}
+}
+
+int
+remote_old_select(int n, struct pt_regs regs)
+{
+	unsigned long a[5];
+
+	if(copy_from_user(a, (char *)ARG(0), sizeof(a)))
+		return(-EFAULT);
+
+	set_write_region(ARG(0), sizeof(a));
+	set_select_regions(a[0], a[1], a[2], a[3], a[4]);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_symlink(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_symlink(const char *, const char *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_symlink((const char *)ARG(0),
+							(const char *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_file_name(1);
+	return(remote_standard_system_call(n, &regs));
+}
+
+
+long
+remote_sys_lstat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_lstat(char *, struct __old_kernel_stat *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_lstat((char *)ARG(0),
+					(struct __old_kernel_stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct __old_kernel_stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_lstat64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_lstat64(char *, struct stat64 *, long);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_lstat64((char *)ARG(0), (struct stat64 *)ARG(1),
+								(long)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct stat64));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_readlink(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_readlink(const char *, char *, int);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_readlink((const char *)ARG(0), (char *)ARG(1),
+								(int)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_uselib(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_swapon(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_old_readdir(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	int result;
+	extern asmlinkage int old_readdir(unsigned int, void *, unsigned int);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = old_readdir(fd, (void *)ARG(1), (unsigned int)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_old_mmap(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), 6 * sizeof(int));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_truncate(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_truncate(const char *, unsigned long);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_truncate((const char *)ARG(0),
+							(unsigned long)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_truncate64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_truncate64(const char *, loff_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_truncate64((const char *)ARG(0), (loff_t)LARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_statfs(int n, struct pt_regs regs)
+{
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct statfs));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_fstatfs(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct statfs));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_socketcall(int n, struct pt_regs regs)
+{
+	unsigned long a[6];
+	unsigned long alen;
+	struct msghdr hdr;
+	int i;
+	struct iovec io;
+
+	set_write_region(ARG(1), 6 * sizeof(int));
+	if(!copy_from_user(a, (char *)ARG(1), 6 * sizeof(int)))
+		switch(ARG(0)) {
+		case SYS_BIND:
+		case SYS_CONNECT:
+			set_write_region(a[1], a[2]);
+			break;
+		case SYS_ACCEPT:
+		case SYS_GETSOCKNAME:
+		case SYS_GETPEERNAME:
+			if(!get_user(alen, (int *)a[2]))
+			{
+				set_write_region(a[2], sizeof(int));
+				set_read_region(a[2], sizeof(int));
+				set_read_region(a[1], alen);
+			     } else{
+                             return (ARG(0)==SYS_ACCEPT)? -EINVAL : -EFAULT;
+			}
+			break;
+		case SYS_SOCKETPAIR:
+			set_read_region(a[3], 2 * sizeof(int));
+			break;
+		case SYS_SEND:
+			set_write_region(a[1], a[2]);
+			break;
+		case SYS_SENDTO:
+			set_write_region(a[1], a[2]);
+			set_write_region(a[4], a[5]);
+			break;
+		case SYS_RECV:
+			set_read_region(a[1], a[2]);
+			break;
+		case SYS_RECVFROM:
+			set_read_region(a[1], a[2]);
+			if(a[4] && !get_user(alen, (int *)a[5]))
+			{
+				set_write_region(a[5], sizeof(int));
+				set_read_region(a[5], sizeof(int));
+				set_read_region(a[4], alen);
+			}
+			break;
+		case SYS_SETSOCKOPT:
+			set_write_region(a[3], a[4]);
+			break;
+		case SYS_GETSOCKOPT:
+			if(!get_user(alen, (int *)a[4]))
+			{
+				set_write_region(a[4], sizeof(int));
+				set_read_region(a[4], sizeof(int));
+				set_read_region(a[3], alen);
+			}
+			break;
+		case SYS_SENDMSG:
+			if(copy_from_user(&hdr, (char *)a[1], sizeof(hdr)))
+				break;
+			set_write_region(a[1], sizeof(hdr));
+			if(hdr.msg_name)
+				set_write_region((unsigned long)hdr.msg_name, hdr.msg_namelen);
+			if(hdr.msg_controllen)
+				set_write_region((unsigned long)hdr.msg_control, hdr.msg_controllen);
+			if(hdr.msg_iovlen > 0)
+			{
+				set_write_region((unsigned long)hdr.msg_iov, hdr.msg_iovlen * sizeof(struct iovec));
+				if(hdr.msg_iovlen > 100)
+					hdr.msg_iovlen = 100;
+				for(i = 0 ; i < hdr.msg_iovlen &&
+					    !copy_from_user(&io, hdr.msg_iov + i,
+							    sizeof(io)) ; i++)
+					set_write_region((unsigned long)io.iov_base, io.iov_len);
+			}
+			break;
+		case SYS_RECVMSG:
+			if(copy_from_user(&hdr, (char *)a[1], sizeof(hdr)))
+				break;
+			set_write_region(a[1], sizeof(hdr));
+			set_read_region(a[1], sizeof(hdr));
+			if(hdr.msg_name)
+				set_read_region((unsigned long)hdr.msg_name, hdr.msg_namelen);
+			if(hdr.msg_control)
+				set_read_region((unsigned long)hdr.msg_control, hdr.msg_controllen);
+			if(hdr.msg_iovlen > 0)
+			{
+				set_write_region((unsigned long)hdr.msg_iov, hdr.msg_iovlen * sizeof(struct iovec));
+				if(hdr.msg_iovlen > 100)
+					hdr.msg_iovlen = 100;
+				for(i = 0 ; i < hdr.msg_iovlen &&
+					    !copy_from_user(&io, hdr.msg_iov + i,
+							    sizeof(io)) ; i++)
+					set_read_region((unsigned long)io.iov_base, io.iov_len);
+			}
+			break;
+		}
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_syslog(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_newstat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_newstat(char *, struct stat *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_newstat((char *)ARG(0), (struct stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_newlstat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_newlstat(char *, struct stat *);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_newlstat((char *)ARG(0),
+					(struct stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	set_read_region(ARG(1), sizeof(struct stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_newfstat(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_newfstat(unsigned int, struct stat *);
+	unsigned int fd = ARG(0);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_newfstat(fd, (struct stat *)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), sizeof(struct stat));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_uname(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(struct old_utsname));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_wait4(int n, struct pt_regs regs)
+{
+	if(ARG(1))
+		set_read_region(ARG(1), sizeof(int));
+	if(ARG(3))
+		set_read_region(ARG(3), sizeof(struct rusage));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sysinfo(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(struct sysinfo));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_ipc(int n, struct pt_regs regs)
+{
+	int call = ARG(0) & 0xffff;
+	int version = ARG(0) >> 16;
+
+	switch (call)
+	{
+	case SEMOP:
+		set_write_region(ARG(4), ARG(2)*sizeof(struct sembuf));
+		break;
+	case SEMCTL: 
+	{
+		unsigned long fourth;
+		int arg3 = ARG(3);
+		ipc_parse_version(&arg3);
+
+		if(get_user(fourth, (unsigned long *)ARG(4)))
+			break;
+		set_read_region(ARG(4), sizeof(long));
+		switch(arg3)
+		{
+		case IPC_INFO:
+		case SEM_INFO:
+			set_read_region(fourth,
+					sizeof(struct seminfo));
+			break;
+		case IPC_STAT:
+		case SEM_STAT:
+			set_read_region(fourth,
+					sizeof(struct semid_ds));
+			break;
+		case IPC_SET:
+			set_write_region(fourth,
+					 sizeof(struct semid_ds));
+		case GETALL:
+			set_read_region(fourth,
+					SEMMNS * sizeof(ushort));
+			break;
+		case SETALL:
+			set_write_region(fourth,
+					 SEMMNS * sizeof(ushort));
+			break;
+		}
+		break;
+	}
+	case MSGSND:
+		set_write_region(ARG(4), sizeof(long) + ARG(2));
+		break;
+	case MSGRCV:
+		switch (version) {
+		case 0: {
+			struct ipc_kludge tmp;
+
+			if (!ARG(4))
+				break;
+			if (copy_from_user(&tmp,(struct ipc_kludge *)
+					   ARG(4), sizeof (tmp)))
+				break;
+			set_read_region(ARG(4), sizeof(tmp));
+			set_read_region((unsigned long)tmp.msgp,
+					sizeof(long) + ARG(2));
+		}
+			break;
+		case 1: default:
+			set_read_region(ARG(4), sizeof(long) + ARG(2));
+			break;
+		}
+		break;
+	case MSGGET:  /* added this so we can return -EINVAL in the default */
+		break;
+	case MSGCTL:
+		switch(ARG(2))
+		{
+		case IPC_INFO:
+		case MSG_INFO:
+			set_read_region(ARG(4),
+					sizeof(struct msginfo));
+			break;
+		case IPC_STAT:
+		case MSG_STAT:
+			set_read_region(ARG(4),
+					sizeof(struct msqid_ds));
+			break;
+		case IPC_SET:
+			set_write_region(ARG(4),
+					 sizeof(struct msqid_ds));
+			break;
+		}
+		break;
+	case SHMCTL:
+		switch(ARG(2))
+		{
+		case IPC_SET:
+			set_write_region(ARG(4),
+					 sizeof(struct shmid_ds));
+			break;
+		case IPC_INFO:
+			set_read_region(ARG(4),
+					sizeof(struct shminfo));
+			break;
+		case SHM_INFO:
+			set_read_region(ARG(4),
+					sizeof(struct shm_info));
+			break;
+		case SHM_STAT:
+			set_read_region(ARG(4),
+					sizeof(struct shmid_ds));
+			break;
+		case IPC_STAT:
+			set_read_region(ARG(4),
+					sizeof(struct shmid_ds));
+		}
+		break;
+		default:
+			return -EINVAL;
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_sigreturn(int n, struct pt_regs regs)
+{
+	set_write_region(regs.esp - 8, 732);
+	/* Eek, struct sigframe not defined outside arch/i386/kernel/signal.c */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_setdomainname(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), ARG(1));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_newuname(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(struct new_utsname));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_adjtimex(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(struct timex));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sigprocmask(int n, struct pt_regs regs)
+{
+	if(ARG(1))
+		set_write_region(ARG(1), sizeof(old_sigset_t));
+	if(ARG(2))
+		set_read_region(ARG(2), sizeof(old_sigset_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+unsigned long
+remote_sys_create_module(int n, struct pt_regs regs)
+{
+	set_file_name(0);	/* not really a file, but still a string */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_init_module(int n, struct pt_regs regs)
+{
+	set_file_name(0);	/* not really a file, but still a string */
+	set_write_region(ARG(1), sizeof(struct module) + 64);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_delete_module(int n, struct pt_regs regs)
+{
+	set_file_name(0);	/* not really a file, but still a string */
+	return(remote_standard_system_call(n, &regs));
+}
+
+void
+set_max_readable(unsigned long addr)
+{
+	struct vm_area_struct * vma;
+
+	vma = find_vma(current->mm, addr);
+	if (vma && (vma->vm_flags & VM_WRITE) && addr >= vma->vm_start)
+		set_read_region(addr, vma->vm_end - addr);
+}
+
+long
+remote_sys_get_kernel_syms(int n, struct pt_regs regs)
+{
+	set_max_readable(ARG(0));
+	return(remote_standard_system_call(n, &regs));
+}
+
+#ifdef CONFIG_QUOTA
+
+#ifdef CONFIG_QFMT_V2
+
+#define Q_COMP_GETQUOTA Q_V2_GETQUOTA
+#define Q_COMP_GETSTATS Q_V2_GETSTATS
+#define Q_COMP_SETQUOTA Q_V2_SETQUOTA
+#define Q_COMP_SETUSE Q_V2_SETUSE
+#define Q_COMP_SETQLIM Q_V2_SETQLIM
+typedef struct v2c_mem_dqblk comp_dqblk;
+typedef struct v2c_dqstats comp_dqstats;
+
+#else
+
+#define Q_COMP_GETQUOTA Q_V1_GETQUOTA
+#define Q_COMP_GETSTATS Q_V1_GETSTATS
+#define Q_COMP_SETQUOTA Q_V1_SETQUOTA
+#define Q_COMP_SETUSE Q_V1_SETUSE
+#define Q_COMP_SETQLIM Q_V1_SETQLIM
+typedef struct v1c_mem_dqblk comp_dqblk;
+typedef struct v1c_dqstats comp_dqstats;
+
+#endif /* CONFIG_QFMT_V2 */
+#endif /* CONFIG_QUOTA */
+
+long
+remote_sys_quotactl(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_QUOTA
+	set_file_name(1);
+	switch(ARG(0))
+	{
+	case Q_COMP_QUOTAON:
+		set_file_name(3);
+		break;
+	case Q_COMP_GETQUOTA:
+		set_read_region(ARG(3), sizeof(comp_dqblk));
+		break;
+	case Q_COMP_GETSTATS:
+		set_read_region(ARG(3), sizeof(comp_dqstats));
+		break;
+	case Q_COMP_SETQUOTA:
+	case Q_COMP_SETUSE:
+	case Q_COMP_SETQLIM:
+		set_write_region(ARG(3), sizeof(comp_dqblk));
+		break;
+	}
+#endif /* CONFIG_QUOTA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_bdflush(int n, struct pt_regs regs)
+{
+	if(ARG(0) >= 2 && !(ARG(0) & 1))
+		set_read_region(ARG(1), sizeof(int));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sysfs(int n, struct pt_regs regs)
+{
+	switch(ARG(0))
+	{
+		case 1:
+			set_file_name(1);
+			break;
+		case 2:
+			set_max_readable(2);
+			break;
+	}
+	return(remote_standard_system_call(n, &regs));
+}
+
+off_t
+remote_sys_lseek(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	off_t result;
+	extern asmlinkage off_t sys_lseek(unsigned int, off_t, unsigned int);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_lseek(fd, ARG(1), ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_llseek(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	long result;
+	extern long sys_llseek(unsigned int, unsigned long, unsigned long,
+		loff_t *, int);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_llseek(fd, ARG(1), ARG(2), (loff_t *)ARG(3),
+									ARG(4));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(3), sizeof(loff_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getdents(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	long result;
+	extern asmlinkage long sys_getdents(unsigned int, void *, unsigned int);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_getdents(fd, (void *)ARG(1), (unsigned int)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getdents64(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	long result;
+	extern asmlinkage long sys_getdents64(unsigned int, void *,
+								unsigned int);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_getdents64(fd, (void *)ARG(1),
+							(unsigned int)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_select(int n, struct pt_regs regs)
+{
+	set_select_regions(ARG(0), ARG(1), ARG(2), ARG(3), ARG(4));
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_readv(int n, struct pt_regs regs)
+{
+	int i, l = ARG(2);
+	struct iovec io;
+
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	ssize_t result;
+	extern asmlinkage ssize_t sys_readv(unsigned int, struct iovec*,
+								unsigned long);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_readv(fd, (struct iovec *)ARG(1),
+							(unsigned long)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	if(l > 0)
+		set_read_region(ARG(1), l * sizeof(struct iovec));
+	if(l > 100)
+		l = 100;	/* do not loop forever here */
+	for(i = 0 ; i < l &&
+		!copy_from_user(&io, ((struct iovec *)ARG(1)) + i, sizeof(io)) ;
+									i++)
+		set_read_region((unsigned long)io.iov_base, io.iov_len);
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_writev(int n, struct pt_regs regs)
+{
+	int i, l = ARG(2);
+	struct iovec io;
+
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	ssize_t result;
+	extern asmlinkage ssize_t sys_writev(unsigned int, struct iovec *,
+								unsigned long);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_writev(fd, (struct iovec *)ARG(1),
+							(unsigned long)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	if(l > 0)
+		set_read_region(ARG(1), l * sizeof(struct iovec));
+	if(l > 100)
+		l = 100;	/* do not loop forever here */
+	for(i = 0 ; i < l &&
+		!copy_from_user(&io, ((struct iovec *)ARG(1)) + i, sizeof(io)) ;
+									i++)
+		set_write_region((unsigned long)io.iov_base, io.iov_len);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sysctl(int n, struct pt_regs regs)
+{
+	struct __sysctl_args args;
+	int oldlen;
+
+	if(copy_from_user((char *)&args, (char *)ARG(0), sizeof(args)))
+		return(-EFAULT);
+	set_read_region(ARG(0), sizeof(args));
+	set_write_region((unsigned long)args.name, args.nlen);
+	if(args.oldval && args.oldlenp && !get_user(oldlen, args.oldlenp))
+	{
+		set_write_region((unsigned long)args.oldlenp, sizeof(int));
+		if(oldlen)
+		{
+			set_read_region((unsigned long)args.oldlenp, sizeof(int));
+			set_read_region((unsigned long)args.oldval, oldlen);
+		}
+	}
+	if(args.newval)
+		set_write_region((unsigned long)args.newval, args.newlen);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sched_setparam(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(1), sizeof(struct sched_param));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sched_getparam(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct sched_param));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sched_setscheduler(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(2), sizeof(struct sched_param));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sched_getscheduler(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(2), sizeof(struct sched_param));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_sched_rr_get_interval(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), sizeof(struct timespec));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_nanosleep(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(struct timespec));
+	set_read_region(ARG(1), sizeof(struct timespec));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getresuid(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(uid_t));
+	set_read_region(ARG(1), sizeof(uid_t));
+	set_read_region(ARG(2), sizeof(uid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getresuid16(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(old_uid_t));
+	set_read_region(ARG(1), sizeof(old_uid_t));
+	set_read_region(ARG(2), sizeof(old_uid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_query_module(int n, struct pt_regs regs)
+{
+	if(ARG(0))
+		set_file_name(0); /* not really a file, but still a string */
+	if(ARG(2))
+		set_read_region(ARG(2), ARG(3));
+	set_read_region(ARG(4), sizeof(size_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_poll(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), ARG(1) * sizeof(struct pollfd));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_nfsservctl(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(1), sizeof(struct nfsctl_arg));
+	set_write_region(ARG(2), sizeof(union nfsctl_res));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_getresgid(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(gid_t));
+	set_read_region(ARG(1), sizeof(gid_t));
+	set_read_region(ARG(2), sizeof(gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_getresgid16(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(old_gid_t));
+	set_read_region(ARG(1), sizeof(old_gid_t));
+	set_read_region(ARG(2), sizeof(old_gid_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_rt_sigreturn(int n, struct pt_regs regs)
+{
+	set_write_region(regs.esp - 8, 892);
+	/*Eek,struct rt_sigframe not defined outside arch/i386/kernel/signal.c*/
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rt_sigaction(int n, struct pt_regs regs)
+{
+	if(ARG(1))
+		set_write_region(ARG(1), sizeof(struct k_sigaction));
+	if(ARG(2))
+		set_read_region(ARG(2), sizeof(struct k_sigaction));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rt_sigprocmask(int n, struct pt_regs regs)
+{
+	if(ARG(1))
+		set_write_region(ARG(1), sizeof(sigset_t));
+	if(ARG(2))
+		set_read_region(ARG(2), sizeof(sigset_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rt_sigpending(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(0), sizeof(sigset_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rt_sigtimewait(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(sigset_t));
+	if(ARG(1))
+		set_read_region(ARG(1), sizeof(siginfo_t));
+	if(ARG(2))
+		set_write_region(ARG(2), sizeof(struct timespec));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_rt_sigqueueinfo(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(2), sizeof(siginfo_t));
+	if(ARG(1))
+		set_read_region(ARG(1), sizeof(siginfo_t));
+	if(ARG(2))
+		set_write_region(ARG(2), sizeof(struct timespec));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_rt_sigsuspend(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(siginfo_t));
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_pread(int n, struct pt_regs regs)
+{
+	set_read_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_pwrite(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(1), ARG(2));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_chown(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_chown(const char *, uid_t, gid_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_chown((const char *)ARG(0), (uid_t)ARG(1),
+								(gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_chown16(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_chown16(const char *, old_uid_t, old_gid_t);
+
+	if(current->mosix.ttab && enter_remote_dfsa_mode())
+	{
+		result = sys_chown16((const char *)ARG(0), (uid_t)ARG(1),
+								(gid_t)ARG(2));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_file_name(0);
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_getcwd(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	long result;
+	extern asmlinkage long sys_getcwd(char *, unsigned long);
+
+	if(current->mosix.ttab && current->fs->pwd && enter_remote_dfsa_mode())
+	{
+		result = sys_getcwd((char *)ARG(0), (unsigned long)ARG(1));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	set_read_region(ARG(0), ARG(1));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_capget(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(struct __user_cap_header_struct));
+	set_read_region(ARG(1), sizeof(struct __user_cap_data_struct));
+	return(remote_standard_system_call(n, &regs));
+}
+
+long
+remote_sys_capset(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(struct __user_cap_header_struct));
+	set_write_region(ARG(1), sizeof(struct __user_cap_data_struct));
+	return(remote_standard_system_call(n, &regs));
+}
+
+int
+remote_sys_sigaltstack(int n, struct pt_regs regs)
+{
+	set_write_region(ARG(0), sizeof(struct sigaltstack));
+	set_read_region(ARG(1), sizeof(struct sigaltstack));
+	return(remote_standard_system_call(n, &regs));
+}
+
+ssize_t
+remote_sys_readahead(int n, struct pt_regs regs)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	unsigned int fd = ARG(0);
+	ssize_t result;
+	extern asmlinkage ssize_t sys_readahead(unsigned int, loff_t, size_t);
+	struct task_struct *p = current;
+
+	if(fd >= p->files->max_fds)
+	{
+		if(p->mosix.ttab)
+			return(-EBADF);
+	}
+	else if(p->files->fd[fd] && enter_remote_dfsa_mode())
+	{
+		result = sys_readahead(fd, (loff_t)LARG(1), (size_t)ARG(3));
+		leave_remote_dfsa_mode();
+		if(RESULT_IS_FINAL(result))
+			return(result);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(remote_standard_system_call(n, &regs));
+}
